Subject: Re: Guix pull failing on ARM 32bit with "Please report the COMPLETE output above by email"

From: Denis 'GNUtoo' Carikli <[email-masked]>
Date: Mon, 23 May 2022 15:40:40 +0200

Hi,

I've now made some free space. So we have:
- 1GiB of RAM and 16GiB of swap:
  > # cat /proc/swaps 
  > Filename				Type		Size		Used		Priority
  > /dev/mmcblk0p1                          partition	16777212	16384		-2

- About 6GiB of free space on / and about 30GiB of free space on /gnu:
> # df -h 
> Filesystem      Size  Used Avail Use% Mounted on
> /dev/root       9.5G  2.8G  6.7G  30% /
> devtmpfs        403M     0  403M   0% /dev
> tmpfs           500M     0  500M   0% /dev/shm
> tmpfs           200M  2.1M  198M   2% /run
> tmpfs           500M     0  500M   0% /tmp
> /dev/mmcblk2p3   16M  5.5M  9.9M  36% /efs
> /dev/mmcblk0p2   42G  3.8G   36G  10% /gnu

And in my case the TMPDIR is in /gnu/tmp so it should have plenty of
space. From /etc/systemd/system/guix-daemon.service:
> Environment=GUIX_LOCPATH='/var/guix/profiles/per-user/root/guix-profile/lib/locale' LC_ALL=en_US.utf8 TMPDIR=/gnu/tmp

So space should not be an issue anymore.

But with (I've fixed the commit to enable to retry with the same
commit):
> do guix pull --commit=f0e9048e98f0789aa98de88984f4ee0fc9687f52

I get the following error:
> Backtrace:
>           13 (primitive-load "/gnu/store/hv9q35aibf5v5ggw3hh0xwy5qzyjbh1c-compute-guix-derivation")
> In ice-9/eval.scm:
>     155:9 12 (_ _)
>     159:9 11 (_ #(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#<directory (guile-u?> ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?))s
> In ice-9/boot-9.scm:
>     152:2 10 (with-fluid* _ _ _)
>     152:2  9 (with-fluid* _ _ _)
> In ./guix/store.scm:
>   2155:24  8 (run-with-store #<store-connection 256.99 b3654cf8> _ #:guile-for-build _ #:system _ #:target _)
>    1983:8  7 (_ _)
> In ./guix/gexp.scm:
>    300:22  6 (_ _)
>    1181:2  5 (_ _)
>    1047:2  4 (_ _)
>     893:4  3 (_ _)
> In ./guix/store.scm:
>   2040:12  2 (_ #<store-connection 256.99 b226d780>)
>    1391:5  1 (map/accumulate-builds #<store-connection 256.99 b226d780> #<procedure b1d2af00 at ./guix/store.scm:20?> ?)
>   1406:15  0 (_ #<store-connection 256.99 b226d780> _ _)
> 
> ./guix/store.scm:1406:15: ERROR:
>   1. &store-protocol-error:
>       message: "some substitutes for the outputs of derivation `/gnu/store/rrxr8v48zvzd73qg6f8wkn5zwbnglg5w-tar-1.34.drv' failed (usually happens due to networking issues); try `--fallback' to build derivation from source "
>       status: 1
> guix pull: error: You found a bug: the program '/gnu/store/hv9q35aibf5v5ggw3hh0xwy5qzyjbh1c-compute-guix-derivation'
> failed to compute the derivation for Guix (version: "f0e9048e98f0789aa98de88984f4ee0fc9687f52"; system: "armhf-linux";
> host version: "1.3.0"; pull-version: 1).
> Please report the COMPLETE output above by email to <[email-masked]>.

And retrying right after gives a similar error:
> Backtrace:
>           13 (primitive-load "/gnu/store/hv9q35aibf5v5ggw3hh0xwy5qzyjbh1c-compute-guix-derivation")
> In ice-9/eval.scm:
>     155:9 12 (_ _)
>     159:9 11 (_ #(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#(#<directory (guile-u?> ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?) ?))
> In ice-9/boot-9.scm:
>     152:2 10 (with-fluid* _ _ _)
>     152:2  9 (with-fluid* _ _ _)
> In ./guix/store.scm:
>   2155:24  8 (run-with-store #<store-connection 256.99 b3698cf8> _ #:guile-for-build _ #:system _ #:target _)
>    1983:8  7 (_ _)
> In ./guix/gexp.scm:
>    300:22  6 (_ _)
>    1181:2  5 (_ _)
>    1047:2  4 (_ _)
>     893:4  3 (_ _)
> In ./guix/store.scm:
>   2040:12  2 (_ #<store-connection 256.99 b36660a0>)
>    1391:5  1 (map/accumulate-builds #<store-connection 256.99 b36660a0> #<procedure b2c94360 at ./guix/store.scm:20?> ?)
>   1406:15  0 (_ #<store-connection 256.99 b36660a0> _ _)
> 
> ./guix/store.scm:1406:15: ERROR:
>   1. &store-protocol-error:
>       message: "some substitutes for the outputs of derivation `/gnu/store/rrxr8v48zvzd73qg6f8wkn5zwbnglg5w-tar-1.34.drv' fai
> led (usually happens due to networking issues); try `--fallback' to build derivation from source "
>       status: 1
> guix pull: error: You found a bug: the program '/gnu/store/hv9q35aibf5v5ggw3hh0xwy5qzyjbh1c-compute-guix-derivation'
> failed to compute the derivation for Guix (version: "f0e9048e98f0789aa98de88984f4ee0fc9687f52"; system: "armhf-linux";
> host version: "1.3.0"; pull-version: 1).
> Please report the COMPLETE output above by email to <[email-masked]>.

I'll try to see if guix pull also works on another ARM device (TBS
2910 with An I.MX6Q and 2GiB of RAM).

If that works I'll simply do a guix pack with -RR of valgrind and gdb
and install that in a directory that is not /gnu. So that would enable
me to keep that Guix installation and wait for help to debug that
issue.

If that doesn't work I'll unfortunately have to uninstall Guix on that
GT-I9300 variant of the Galaxy SIII and instead cross compile a guix
pack with valgrind and gdb on an x86 computer without -RR (-R and -RR
aren't supported in cross compilation).

This is because I also need to continue working on making the modem
work as part of my work on Replicant 11 (I use GNU/Linux here as they
share part of the stack and GNU/Linux is easier to work with) and I
can't delay that work forever in the hope of solving a Guix bug, and
here I've no idea of the cause and so I would need some help, and if
I keep delaying that work too much I will be in big trouble as NLnet
is running out of funds in the fund that funds this work.

Denis.